## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Tests for students containers.
"""
import unittest
from zope.interface.verify import verifyClass, verifyObject
from zope.component.interfaces import IFactory
from zope.app.testing.functional import FunctionalTestCase
from waeup.sirp.students.interfaces import (
    IStudentsContainer,
    )
from waeup.sirp.students.container import (
    StudentsContainer, 
    )
from waeup.sirp.testing import FunctionalLayer

class StudentsContainerTestCase(unittest.TestCase):

    def test_interfaces(self):
        # Make sure the correct interfaces are implemented.
        self.assertTrue(
            verifyClass(
                IStudentsContainer, StudentsContainer)
            )
        self.assertTrue(
            verifyObject(
                IStudentsContainer, StudentsContainer())
            )
        return

    def test_base(self):
        # We cannot call the fundamental methods of a base in that case
        container = StudentsContainer()
        self.assertRaises(
            NotImplementedError, container.archive)
        self.assertRaises(
            NotImplementedError, container.clear)
